package com.zipcodewilmington;

import javax.print.DocFlavor;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Created by leon on 1/29/18.
 */
public class StringArrayUtils<start, end> {
    /**
     * @param array array of String objects
     * @return first element of specified array
     */ // TODO
    public static String getFirstElement(String[] array) {

        return array[0];
    }

    /**
     * @param array array of String objects
     * @return second element in specified array
     */
    public static String getSecondElement(String[] array) {

        return array[1];
    }

    /**
     * @param array array of String objects
     * @return last element in specified array
     */ // TODO
    public static String getLastElement(String[] array) {
        return array[array.length - 1];
    }

    /**
     * @param array array of String objects
     * @return second to last element in specified array
     */ // TODO
    public static String getSecondToLastElement(String[] array) {
        return array[array.length - 2];
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return true if the array contains the specified `value`
     */ // TODO
    public static boolean contains(String[] array, String value) {
        boolean str = false;
        for (int x = 0; x < array.length; x++) {
            if (value.equals(array[x])) {
                      str = true;
            }
        } return str;
    }

    /**
     * @param array of String objects
     * @return an array with identical contents in reverse order
     */ // TODO
    public static String[] reverse (String[] array) {

        String[] str = new String[array.length];

        // for (int i = 0; i < array.length; i++ ){
        for (int i = (array.length - 1); i >= 0; i--) {
            str[i] = array[array.length - (i + 1)];
        }
        return str;
    }

    /**
     * @param array array of String objects
     * @return true if the order of the array is the same backwards and forwards
     */ // TODO
    public static boolean isPalindromic(String[] array) {

        for (int i = 0; i < array.length / 2; i++) {
            if (array[i] != array[array.length - 1 - i]) {
                return false;
            }
        }
        return true;
    }


    /** // if the control reaches here, means all the elements were same
     * @parareturn true;m array array of String objects
     * @retu}rn true if each letter in the alphabet has been used in the array
     */ // TODO
    public static boolean isPangramic(String[] array) {

              boolean isAPanGramic = true;
              String strLower = "";

          //Array - toLowerCase - Concat
              for (String var : array) {
                  strLower = strLower.concat(var.toLowerCase());
              }
          //loop through ANSI lower case values a-z
              // IF! contains - boolean set to false
              for(int i = 97; i <= 122; i++){
                  if(!strLower.contains(Character.toString((char)i))){
                      isAPanGramic = false;
                  }
              }
              return isAPanGramic;
          }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return number of occurrences the specified `value` has occurred
     */ // TODO
    public static int getNumberOfOccurrences(String[] array, String value) {
          int count = 0;

          for (String str: array){
              if(value.equals(str) )
                  count++;
          }
          return count;
    }

    /**
     * @param array array of String objects
     * @param valueToRemove value to remove from array
     * @return array with identical contents excluding values of `value`
     */ // TODO
    public static String[] removeValue(String[] array, String valueToRemove) {

              List<String> list = new ArrayList<String>(Arrays.asList(array));

              list.remove(valueToRemove);

              array = list.toArray(new String[0]);


              return array;

   }
    /**
     * @param array array of chars
     * @return array of Strings with consecutive duplicates removes
     */ // TODO
    public static String[] removeConsecutiveDuplicates(String[] array) {


        ArrayList<String> rm = new ArrayList<String>();
        rm.add(array[0]);
        for (int i = 1; i < array.length; i++) {

            if (!array[i - 1].equals(array[i])) {

                rm.add(array[i]);
            }
        }

        String[] newArray = new String[rm.size()];
        newArray = rm.toArray(new String[rm.size()]);

        return newArray;
    }
    
    /**
     * @par  return newList;am array array of chars
     * @ret}urn array of Strings with each consecutive duplicate occurrence concatenated as a single string in an array of Strings
     */ // TODO
    public static String[] packConsecutiveDuplicates(String[] array) {


        ArrayList<String> arrayList = new ArrayList<String>();
        String stri = new String();

        stri = array[0];

        arrayList.add(array[0]);
        for (int i = 1; i < array.length; i++) {

            if (array[i] == stri) {

                arrayList.set(arrayList.size() - 1, arrayList.get(arrayList.size() - 1) + array[i]);

            } else {

                arrayList.add(array[i]);

                stri = array[i];

            }

        }
        String[] newArray = new String[arrayList.size()];
        newArray = arrayList.toArray(new String[arrayList.size()]);

        return newArray;
    }


    }